Ptychokeras.py is a framework for ptychographical reconstructions using automatic differentiation. It is written in Python3 and uses custom Keras layers with TensorFlow as a backend.

The code has been tested on Linux and requires the following Python packages (which can be readily installed using conda):

- Python=3.7
- tensorflow=2.1 or tensorflow-gpu=2.1
- numpy=1.18

recommended packages:
- matplotlib (otherwise, comment out plotting commands)


Example command for a complete installation (with GPU support):

conda install python=3.7 tensorflow-gpu matplotlib numpy toml

without GPU support:

conda install python=3.7 tensorflow matplotlib numpy toml


You can find an example dataset of diffraction patterns in the directory ./ptycho_data. Run the script without modifications to reconstruct this dataset either by using spyder (or similar) or by executing 'python3 ptychokeras.py'. 
Edit ./functions/ptycho_datasets.py to reconstruct your own datasets and follow the data structure found in the given example.